#!/bin/sh

PATH=$PATH:/usr/sbin
export PATH

read cmd
if [ ! -d $cmd ]; then
  mkdir $cmd
fi
TET_ROOT=$cmd
read cmd
INSTALL_TET_ROOT=$cmd
export TET_ROOT INSTALL_TET_ROOT
read cmd
tet_package=$PWD/$cmd
(cd $TET_ROOT && tar xjf $tet_package)

# Install the test suites
test_suites=`echo lts_*.tar.bz2 | sed -e s/\ +//`
current_dir=$PWD;
for test_suite in $test_suites; do
  (cd $TET_ROOT/test_sets && tar xjf $current_dir/$test_suite)
done;

# Configure setup script and profiles
sed -e "s@^echo Unconfigured@TET_ROOT=$INSTALL_TET_ROOT@" $TET_ROOT/setup.sh.skeleton \
  > $TET_ROOT/setup.sh && rm $TET_ROOT/setup.sh.skeleton
sed -e "s@^echo Unconfigured@TET_ROOT=$INSTALL_TET_ROOT@" $TET_ROOT/profile.skeleton \
  > $TET_ROOT/profile && rm $TET_ROOT/profile.skeleton
sed -e "s@^echo Unconfigured@TET_ROOT=$INSTALL_TET_ROOT@" $TET_ROOT/test_sets/profile.skeleton  > $TET_ROOT/test_sets/profile && rm $TET_ROOT/test_sets/profile.skeleton

# Set ownership correctly
echo Setting up ownership and permissions correctly
chmod u+x $TET_ROOT/setup.sh



