%define name lsb-testsuites
%define version 1.0.1.2
%define litever 1.0
%define fhsver 1.0.1.4
%define ugver 1.0.1.4
%define vsxgenver 2.0
%define devchkver 1.0.0.1
%define osver 1.0.2.1beta
%define release 0.2mdk

Summary: LSB test suite
Name: %{name}
Version: %{version}
Release: %{release}
Source0: install.sh
Source1: ftp://ftp.xopen.org/pub/lsb/test_suites/lts_vsx-pcts-%{version}.tar.bz2
Source2: ftp://ftp.xopen.org/pub/lsb/test_suites/tet_vsxgen_%{vsxgenver}.tar.bz2
Source3: ftp://ftp.xopen.org/pub/lsb/test_suites/lts_vsthlite_%{litever}.tar.bz2
Source4: ftp://ftp.xopen.org/pub/lsb/test_suites/README
Source5: ftp://ftp.xopen.org/pub/lsb/test_suites/beta/lts_lsb-fhs-%{fhsver}.tar.bz2
Source6: ftp://ftp.xopen.org/pub/lsb/test_suites/beta/lts_usersgroups-%{ugver}.tar.bz2
Source7: ftp://ftp.xopen.org/pub/lsb/test_suites/beta/lsb-devchk-%{devchkver}.tar.bz2
Source8: ftp://ftp.freestandards.org/pub/lsb/test_suites/beta/source/distribution/lts_lsb-os-%{osver}.tar.bz2
Source9: lsb-devchk

License: GPL
URL: http://www.freestandards.org/lsb
Group: Development/Other
BuildRoot: %{_tmppath}/%{name}-buildroot
Prefix: %{_prefix}
Requires: byacc gcc make perl-base sed pax ed
BuildArch: noarch

%description

This package contains a Linux Standard Base (LSB) test suite.
To initiate the tests, create a password for user vsx0, log in
as vsx0, and type: "lsb-test". As a minimum, select "lsb-fhs" 
when prompted for test sets.

Additionally, the lsb-devchk test can also be run by the vsx0 user. 
This test examines system header files for LSB compliance.

%prep 
rm -rf ${RPM_BUILD_DIR}/%{name}-%{version}
mkdir $RPM_BUILD_DIR/%{name}-%{version}
tar -xjf %{SOURCE7}

cp %{SOURCE0} %{SOURCE1} %{SOURCE2} %{SOURCE3} %{SOURCE4} \
	%{SOURCE5} %{SOURCE6} %{SOURCE8} $RPM_BUILD_DIR/%{name}-%{version}

%build

%install
# using the normal spec-helper stuff on this seems to break it (sb)
export DONT_CLEANUP=1
export DONT_COMPRESS=1
export DONT_STRIP=1
export DONT_RELINK=1
export DONT_SYMLINK_LIBS=1
export DONT_CLEAN_PERL=1

rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/%{_libdir}/%{name}/

cd $RPM_BUILD_DIR/%{name}-%{version}
sh %{SOURCE0} <<EOF
$RPM_BUILD_ROOT/%{_libdir}/%{name}
%{_libdir}/%{name}
tet_vsxgen_%{vsxgenver}.tar.bz2
EOF

rm $RPM_BUILD_ROOT/%{_libdir}/%{name}/test_sets/SRC/common/lsbutils/lsb_devstat
rm $RPM_BUILD_ROOT/%{_libdir}/%{name}/test_sets/SRC/common/lsbutils/lsb_execwithpriv
rm $RPM_BUILD_ROOT/%{_libdir}/%{name}/test_sets/SRC/common/lsbutils/lsb_issymlink
rm $RPM_BUILD_ROOT/%{_libdir}/%{name}/test_sets/SRC/common/lsbutils/lsb_realpath

mkdir -p $RPM_BUILD_ROOT/%{_bindir}/
cp $RPM_BUILD_ROOT/%{_libdir}/%{name}/setup.sh $RPM_BUILD_ROOT/%{_bindir}/lsb-test
cat > $RPM_BUILD_ROOT/%{_bindir}/lsb-test-auto <<EOF
#!/bin/sh

yes "" | %{_bindir}/lsb-test

EOF

cp %{SOURCE9} $RPM_BUILD_ROOT/%{_bindir}
cp $RPM_BUILD_DIR/lsb-devchk-1.0/test_sets/License.devchk $RPM_BUILD_ROOT/%{_libdir}/%{name}/test_sets
cp $RPM_BUILD_DIR/lsb-devchk-1.0/test_sets/tetbuild.cfg $RPM_BUILD_ROOT/%{_libdir}/%{name}/test_sets/lsbdev_build.cfg
cp $RPM_BUILD_DIR/lsb-devchk-1.0/test_sets/tetexec.cfg $RPM_BUILD_ROOT/%{_libdir}/%{name}/test_sets/lsbdev_exec.cfg
mkdir $RPM_BUILD_ROOT/%{_libdir}/%{name}/test_sets/TESTROOT/tset
cp -r $RPM_BUILD_DIR/lsb-devchk-1.0/test_sets/ts/devchk $RPM_BUILD_ROOT/%{_libdir}/%{name}/test_sets/TESTROOT/devchk

cat > $RPM_BUILD_ROOT/%{_libdir}/%{name}/test_sets/lsbdev_scen <<EOF
# devchk test suite

all
        "Starting Full Test Suite"
        /TESTROOT/devchk/hdrchk
        "Completed Full Test Suite"

 
EOF

cat > $RPM_BUILD_ROOT/%{_libdir}/%{name}/test_sets/.profile <<EOF
#add /usr/sbin to PATH for usersgroups testing
export PATH=\$PATH:/usr/sbin

EOF

chmod oug+x  $RPM_BUILD_ROOT/%{_bindir}/lsb-test \
	$RPM_BUILD_ROOT/%{_bindir}/lsb-test-auto \
	$RPM_BUILD_ROOT/%{_bindir}/lsb-devchk

%pre

add_single_group()
{
  if [ -n "$GROUP_ID" ]; then
    GROUP_ID=$(($GROUP_ID+1))
    GROUP_FLAGS="-g $GROUP_ID"
  fi
  set -x
  groupadd $GROUP_FLAGS $1
  GROUP_ADD=$?
  set +x
  if [ $GROUP_ADD -ne 0 -a -z "$GROUP_ID" ]; then
    grep $1 /etc/group
    if [ $? -ne 0 ]; then
      # work out a group id we can use
      # Serious dodgy algorithm but avoids the problem of 
      # nogroup often being set to the last valid gid
      GROUP_ID=`cut -f3 -d: /etc/group | sort -n | tail -2 | head -1`;
      GROUP_ID=$(($GROUP_ID+10))
      GROUP_FLAGS="-g $GROUP_ID"
      set -x
      groupadd $GROUP_FLAGS $1
      set +x
    fi
  fi
}

uidsetup() 
{
  # add the maximum number of groups for a user
  add_single_group  vsxg0
  add_single_group  vsxg1
  add_single_group  vsxg2
  # note that this is to NGROUP_MAX , vsxg0 + NGROUP_MAX supp groups
  add_single_group  supp1
  add_single_group  supp2
  add_single_group  supp3
  add_single_group  supp4
  add_single_group  supp5
  add_single_group  supp6
  add_single_group  supp7
  add_single_group  supp8
  add_single_group  supp9
  add_single_group  supp10
  add_single_group  supp11
  add_single_group  supp12
  add_single_group  supp13
  add_single_group  supp14
  add_single_group  supp15
  add_single_group  supp16
  add_single_group  supp17
  add_single_group  supp18
  add_single_group  supp19
  add_single_group  supp20
  add_single_group  supp21
  add_single_group  supp22
  add_single_group  supp23
  add_single_group  supp24
  add_single_group  supp25
  add_single_group  supp26
  add_single_group  supp27
  add_single_group  supp28
  add_single_group  supp29
  add_single_group  supp30
  add_single_group  supp31
  
  #had to break this into 2 steps, or it fails if first install (sb)

  useradd -g vsxg0 -d $TET_ROOT -s /bin/sh -c "VSX0 test login" vsx0
  usermod -d $TET_ROOT/test_sets vsx0

  if [ -z "$GROUP_ID" ]; then
    USER_MOD_FLAG="-G"
  else
    USER_MOD_FLAG="-g"
  fi

  usermod $USER_MOD_FLAG supp1,supp2,supp3,supp4,supp5,supp6,supp7,supp8,supp9,supp10,supp11,supp12,supp13,supp14,supp15,supp16,supp17,supp18,supp19,supp20,supp21,supp22,supp23,supp24,supp25,supp26,supp27,supp28,supp29,supp30,supp31 vsx0

  useradd -g vsxg1 -d $TET_ROOT -s /bin/sh -c "VSX1 test login" vsx1
  useradd -g vsxg2 -d $TET_ROOT -s /bin/sh -c "VSX2 test login" vsx2
}

######################################################################

export TET_ROOT=$RPM_BUILD_ROOT/%{_libdir}/%{name}

# Check that user id's are setup
# We check that vsx1 user exists instead of vsx0 as some
# test suites have more stringent user and group requirments
# than others
grep vsx1 /etc/passwd 2>&1 >/dev/null
if [ $? -ne 0 ]; then
  uidsetup
else
  usermod -d $TET_ROOT/test_sets vsx0
  usermod -d $TET_ROOT vsx1
  usermod -d $TET_ROOT vsx2
fi

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,vsx0,vsxg0)
%attr(-,root,root) %doc %{name}-%{version}/README
%{_libdir}/%{name}/
%{_bindir}/lsb-test
%{_bindir}/lsb-devchk
#%{_bindir}/lsb-test-auto

%changelog
* Fri Nov 30 2001 Stew Benedict <sbenedict@mandrakesoft.com> 1.0.1.2-0.2mdk 
- lsb-usersgroups-1.0.1.4, .tgz's to tar.bz2, update install.sh to accomodate

* Mon Nov 26 2001 Stew Benedict <sbenedict@mandrakesoft.com> 1.0.1.2-0.1mdk
- vsx-pcts-1.0.1.2, lsb-fhs-1.0.1.4

* Sat Oct  6 2001 Stew Benedict <sbenedict@mandrakesoft.com> 1.0.1.1-0.8mdk
- bump tet_vsxgen to 2.0, lsb-os to 1.0.2.1beta (some tests removed)
- tests reworked to support /bin/sh = ash
- libraries moved from tet_vsxgen --> lsb-os, lsb-os docs added
- update usersgroups to 1.0.1.2

* Fri Sep 14 2001 Stew Benedict <sbenedict@mandrakesoft.com> 1.0.1.1-0.7mdk
- add /usr/sbin to vsx0's path, fhs to 1.0.1.3 (UNIX98 mode)

* Wed Sep 12 2001 Stew Benedict <sbenedict@mandrakesoft.com> 1.0.1.1-0.6mdk
- update usersgroups to 1.0.1.1beta, vsxgen to 1.3, pcts to 1.0.1.1
- add lsb-os at 1.0.1.1beta - disabled for now - breaks other tests

* Tue Aug 28 2001 Stew Benedict <sbenedict@mandrakesoft.com> 1.0-0.5mdk
- integrate lsb-devchk

* Thu Aug  9 2001 Stew Benedict <sbenedict@mandrakesoft.com> 1.0-0.4mdk
- update tet_vsxgen to 1.2 - fix setup.sh for tet_vsxgen_version

* Sun Aug  5 2001 Stew Benedict <sbenedict@mandrakesoft.com> 1.0-0.3mdk
- updated tet_vsxgen, added lts_lsb-fhs2, lts_usersgroups beta tests

* Fri Jul 27 2001 Warly <warly@mandrakesoft.com> 1.0-0.2mdk
- renamed lsb-testsuites

* Thu Jul 26 2001 Warly <warly@mandrakesoft.com> 1.0-1mdk
- first package


# end of file
